# @billogram/foundation-form

> A React form component

## Install

```
yarn add @billogram/foundation-form
```

## Usage

```tsx
import {
    FoundationForm,
    FoundationFormConsumer,
    FoundationFormProvider,
    useForm,
} from '@billogram/foundation-form';
```

See [types](src/types.ts) for exported types.

### [`FoundationForm`](src/FoundationForm.tsx)

```tsx
<FoundationForm
    initialValues={ {
        text: '',
    } }>
    { (form) => (
        <FoundationTextbox
            { ...form.fields.text } />
    ) }
</FoundationForm>
}
```

## Note

This library is being published with our use cases in mind and is not necessarily meant to be consumed by the broader public. We probably won't take your feature requests unless they align with our own needs.

## License

MIT
