import React from 'react';
import type { FoundationFormErrors, FoundationFormProps, FoundationFormValueObject, FoundationFormValuesState } from './types';
import './FoundationForm.scss';
declare function noop(): void;
interface State<TFormValues extends FoundationFormValueObject> extends FoundationFormValuesState<TFormValues> {
    errors: FoundationFormErrors;
    isSubmitting: boolean;
}
export default class FoundationForm<TFormValues extends FoundationFormValueObject, TData = unknown> extends React.Component<FoundationFormProps<TFormValues, TData>, State<TFormValues>> {
    static defaultProps: {
        enableReinitialize: boolean;
        keepSuccessfulIsSubmitting: boolean;
        mergeValuesOnReinitialize: boolean;
        onReset: typeof noop;
        onSubmitError: typeof noop;
        onSubmitSuccess: typeof noop;
        resetOnSubmitSuccess: boolean;
        submit: (values: FoundationFormValueObject) => Promise<unknown>;
        wrapInForm: boolean;
    };
    static getDerivedStateFromProps<U extends FoundationFormValueObject>(nextProps: FoundationFormProps<U>, prevState: State<U>): Partial<State<U>>;
    constructor(props: FoundationFormProps<TFormValues, TData>);
    addArrayElement: (name: string, initialValues: FoundationFormValueObject) => Promise<void>;
    change: (name: string, value: unknown) => Promise<void>;
    removeArrayElementAt: (name: string, index: number) => Promise<void>;
    removeAllArrayElements: (name: string) => Promise<void>;
    reset: () => void;
    submit: () => Promise<void>;
    render(): React.ReactNode;
}
export {};
