import _regeneratorRuntime from "@babel/runtime/regenerator";
import _typeof from "@babel/runtime/helpers/typeof";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import equal from 'fast-deep-equal';
import lodash from 'lodash';
import addArrayElement from './utils/addArrayElement';
import change from './utils/change';
import getFormFields from './utils/getFormFields';
import removeAllArrayElements from './utils/removeAllArrayElements';
import removeArrayElementAt from './utils/removeArrayElementAt';
import validate from './validation/validate';
import FoundationFormAsDivWrapper from './FoundationFormAsDivWrapper';
import FoundationFormWrapper from './FoundationFormWrapper';
import './FoundationForm.scss';

function noop() {}

var FoundationForm = /*#__PURE__*/function (_React$Component) {
  _inherits(FoundationForm, _React$Component);

  var _super = _createSuper(FoundationForm);

  _createClass(FoundationForm, null, [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      // Reinitialization should definitely not be the default case, only a few forms might need it and it
      // creates problems for the default pattern.
      if (nextProps.enableReinitialize === true) {
        // Clone in order to get rid of immutable stuff.
        var nextInitialValues = lodash.cloneDeep(nextProps.initialValues);

        if (!equal(prevState.initialValues, nextInitialValues)) {
          if (nextProps.mergeValuesOnReinitialize === true) {
            return {
              initialValues: lodash.merge({}, nextInitialValues, prevState.initialValues),
              rawValues: lodash.merge({}, nextInitialValues, prevState.rawValues),
              submitValues: lodash.merge({}, nextInitialValues, prevState.submitValues)
            };
          }

          return {
            initialValues: nextInitialValues,
            rawValues: nextInitialValues,
            submitValues: nextInitialValues
          };
        }
      }

      return {};
    }
  }]);

  function FoundationForm(props) {
    var _this;

    _classCallCheck(this, FoundationForm);

    _this = _super.call(this, props); // Clone in order to get rid of immutable stuff.

    _defineProperty(_assertThisInitialized(_this), "addArrayElement", function (name, initialValues) {
      return new Promise(function (resolve) {
        _this.setState(addArrayElement(name, initialValues), resolve);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "change", function (name, value) {
      return new Promise(function (resolve) {
        _this.setState(change(name, value), resolve);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "removeArrayElementAt", function (name, index) {
      return new Promise(function (resolve) {
        _this.setState(removeArrayElementAt(name, index), resolve);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "removeAllArrayElements", function (name) {
      return new Promise(function (resolve) {
        _this.setState(removeAllArrayElements(name), resolve);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "reset", function () {
      _this.setState(function (prevState) {
        return {
          errors: {},
          rawValues: prevState.initialValues,
          submitValues: prevState.initialValues
        };
      }, function () {
        _this.props.onReset();
      });
    });

    _defineProperty(_assertThisInitialized(_this), "submit", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var submitValues, data, hasErrorObject, errors;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              submitValues = _this.state.submitValues;
              _context.prev = 1;
              validate(submitValues, _this.props.validators);

              _this.setState({
                errors: {},
                isSubmitting: true
              });

              _context.next = 6;
              return _this.props.submit(submitValues);

            case 6:
              data = _context.sent;

              _this.setState({
                isSubmitting: _this.props.keepSuccessfulIsSubmitting === true
              }, function () {
                _this.props.onSubmitSuccess(data, submitValues);

                if (_this.props.resetOnSubmitSuccess === true) {
                  _this.reset();
                }
              });

              _context.next = 21;
              break;

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](1);
              // @ts-expect-error TS2571
              hasErrorObject = _context.t0 !== null && _context.t0 !== undefined && _typeof(_context.t0.data) === 'object'; // @ts-expect-error TS2571

              errors = hasErrorObject ? _context.t0.data : {};

              if (hasErrorObject) {
                _context.next = 20;
                break;
              }

              if (!(_context.t0.status !== undefined)) {
                _context.next = 19;
                break;
              }

              console.warn('Expected `e.data` to be an error object.');
              _context.next = 20;
              break;

            case 19:
              throw _context.t0;

            case 20:
              _this.setState({
                errors: errors,
                isSubmitting: false
              }, function () {
                // @ts-expect-error TS2571
                _this.props.onSubmitError(errors, submitValues, _context.t0.isClientSideValidationError === true);
              });

            case 21:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[1, 10]]);
    })));

    var _initialValues = lodash.cloneDeep(props.initialValues);

    _this.state = {
      errors: {},
      initialValues: _initialValues,
      isSubmitting: false,
      rawValues: _initialValues,
      submitValues: _initialValues
    };
    return _this;
  }

  _createClass(FoundationForm, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
          errors = _this$state.errors,
          initialValues = _this$state.initialValues,
          isSubmitting = _this$state.isSubmitting,
          rawValues = _this$state.rawValues,
          submitValues = _this$state.submitValues;
      var fields = getFormFields(initialValues, submitValues, rawValues, errors, {
        addArrayElement: this.addArrayElement,
        change: this.change,
        removeArrayElementAt: this.removeArrayElementAt,
        removeAllArrayElements: this.removeAllArrayElements
      });
      var context = {
        errors: errors,
        fields: fields,
        hasErrors: Object.keys(errors).length > 0,
        isSubmitting: isSubmitting,
        reset: this.reset,
        submit: this.submit,
        values: submitValues
      };

      if (this.props.wrapInForm !== true) {
        return /*#__PURE__*/React.createElement(FoundationFormAsDivWrapper, {
          submit: this.submit
        }, this.props.children(context));
      }

      return /*#__PURE__*/React.createElement(FoundationFormWrapper, {
        reset: this.reset,
        submit: this.submit
      }, this.props.children(context));
    }
  }]);

  return FoundationForm;
}(React.Component);

_defineProperty(FoundationForm, "defaultProps", {
  enableReinitialize: false,
  keepSuccessfulIsSubmitting: false,
  mergeValuesOnReinitialize: false,
  onReset: noop,
  onSubmitError: noop,
  onSubmitSuccess: noop,
  resetOnSubmitSuccess: true,
  submit: function submit(values) {
    return Promise.resolve(values);
  },
  wrapInForm: true
});

export { FoundationForm as default };
//# sourceMappingURL=FoundationForm.js.map