import React from 'react';
import purebem from 'purebem';
export default function FoundationFormWrapper(_ref) {
  var children = _ref.children,
      reset = _ref.reset,
      submit = _ref.submit;

  function onReset(evt) {
    evt.preventDefault(); // If we have a form (#1) in a portal that was opened by a button that was in a form (#2), submitting #1 will also submit #2.

    evt.stopPropagation();
    reset();
  }

  function onSubmit(evt) {
    evt.preventDefault(); // If we have a form (#1) in a portal that was opened by a button that was in a form (#2), submitting #1 will also submit #2.

    evt.stopPropagation();
    submit();
  }

  var block = purebem('foundation-form');
  return /*#__PURE__*/React.createElement("form", {
    className: block(),
    onReset: onReset,
    onSubmit: onSubmit
  }, children);
}
//# sourceMappingURL=FoundationFormWrapper.js.map