import type {
    FoundationFormValue,
    FoundationFormValueArray,
    FoundationFormValueObject,
} from './types';


describe('value', () => {
    test('string', () => {
        const value: FoundationFormValue = 'value';
        expect(value).toBeDefined();
    });
});

describe('object', () => {
    test('flat', () => {
        const obj: FoundationFormValueObject = {
            value: 'value',
        };

        expect(obj).toBeDefined();
    });

    test('deep', () => {
        const obj: FoundationFormValueObject = {
            value: {
                node: {
                    leaf: 'value',
                },
            },
        } ;

        expect(obj).toBeDefined();
    });
});

describe('array', () => {
    test('flat', () => {
        const array: FoundationFormValueArray = [{
            value: 'value',
        }];

        expect(array).toBeDefined();
    });

    test('deep', () => {
        const obj: FoundationFormValueArray = [{
            value: [{
                value: [{
                    value: 'value',
                }],
            }],
        }];

        expect(obj).toBeDefined();
    });
});

describe('values', () => {
    test('flat', () => {
        const values: FoundationFormValueObject = {
            value: 'value',
        };

        expect(values).toBeDefined();
    });

    test('nested', () => {
        const values: FoundationFormValueObject = {
            value: {
                node: {
                    leaf: 'value',
                },
            },
        };

        expect(values).toBeDefined();
    });

    test('array', () => {
        const values: FoundationFormValueObject = {
            value: [{
                value: [{
                    value: 'value',
                }],
            }],
        };

        expect(values).toBeDefined();
    });
});
