import opi from 'object-path-immutable';
import isInstanceOf from '@billogram/is-instance-of';
export default function change(name, value) {
  return function setState(prevState) {
    if (isInstanceOf(value, 'rawValue', 'value')) {
      return {
        rawValues: opi.set(prevState.rawValues, name, value.rawValue),
        submitValues: opi.set(prevState.submitValues, name, value.value)
      };
    }

    return {
      rawValues: opi.set(prevState.rawValues, name, value),
      submitValues: opi.set(prevState.submitValues, name, value)
    };
  };
}
//# sourceMappingURL=change.js.map