import money from '@billogram/money';

import getErrorKey from './getErrorKey';


test('plain string', () => {
    const errorKey = getErrorKey('key', 'unknown');
    expect(errorKey).toBe('key');
});

test('dotted string', () => {
    const errorKey = getErrorKey('nested.key', 'unknown');
    expect(errorKey).toBe('nested.key');
});

test('array', () => {
    const errorKey = getErrorKey('array.0.key', 'unknown');
    expect(errorKey).toBe('array.[0].key');
});

test('nested array', () => {
    const errorKey = getErrorKey('nested.0.array.0.key', 'unknown');
    expect(errorKey).toBe('nested.[0].array.[0].key');
});

test('money object', () => {
    const value = money.create(1, 'SEK');

    const errorKey = getErrorKey('key', value);
    expect(errorKey).toBe('key.value');
});
