import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import ClientSideValidationError from './ClientSideValidationError';
import mergeShallow from './mergeShallow';

function traverse(values, validators) {
  function reducer(errors, _ref) {
    var _ref2 = _slicedToArray(_ref, 3),
        key = _ref2[0],
        validator = _ref2[1],
        value = _ref2[2];

    // I don't feel comfortable changing this at the moment.
    // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    if (validator === void 0) {
      return errors;
    }

    if (Array.isArray(validator) && Array.isArray(value)) {
      return validator.reduce(function (err, val, index) {
        return _objectSpread(_objectSpread({}, err), traverse(value[index], val));
      }, errors);
    }

    if (typeof validator === 'function') {
      var context = {
        key: key,
        value: value,
        values: values
      };
      var err = validator(context);

      if (err.length === 0) {
        return errors;
      }

      return _objectSpread(_objectSpread({}, errors), {}, _defineProperty({}, key, err));
    }

    return traverse(value, validator);
  }

  var entries = mergeShallow( // @ts-expect-error TS2345: let's ignore this for now until we got more time to look at it.
  validators, values);
  return entries.reduce(reducer, {});
}

export default function validate(values, validators) {
  var errors = validators !== void 0 && Object.entries(validators).length > 0 ? traverse(values, validators) : {};

  if (Object.keys(errors).length > 0) {
    throw new ClientSideValidationError({
      data: errors
    });
  }
}
//# sourceMappingURL=validate.js.map